﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Pattogó_labda_2
{
    public partial class MainForm : Form
    {
        Ball labda = new Ball(new Point(100, 100), new Size(40, 40), new SolidBrush(Color.Maroon));

      

        
        int xsebesség = 0;
        int ysebesség = 0;
        float xfék = 0.5f;
        float yfék = 0.15f;

        int pontszám = 0;
        int rúgás = 5;

       
        int baloldal;
        int jobboldal;
        int plafon;
        int padló;
       

        public void Fal()
        {
            baloldal = 0;
            jobboldal = ClientSize.Width - labda.Méret.Width - 1;
            plafon = 0;
            padló = ClientSize.Height - labda.Méret.Width - 1;
        }


        public void Pattan()
        {
            //Bal
            if (labda.Koordináta.X < baloldal)
            {
                labda.Koordináta = new Point(baloldal, labda.Koordináta.Y);
                xsebesség = (int)(xsebesség * (1.0f - xfék));
                             
                 xsebesség*=-1;
                
            }
            //Jobb
            if (labda.Koordináta.X > jobboldal)
            {
                labda.Koordináta = new Point(jobboldal, labda.Koordináta.Y);
                xsebesség = (int)(xsebesség * (1.0f - xfék));
                            
                xsebesség *= -1;

            }
            //Padló
            if (labda.Koordináta.Y > padló)
            {
                labda.Koordináta = new Point(labda.Koordináta.X, padló);                
                ysebesség *= -1;
                ysebesség = (int)(ysebesség * (1.0f - yfék));
            }
            //Plafon
            if (labda.Koordináta.Y < plafon)
            {
                labda.Koordináta = new Point(labda.Koordináta.X,plafon);
                
                ysebesség *= -1;
                ysebesség = (int)(ysebesség * (1.0f - yfék));
            }
        }

        public MainForm()
        {
            
            InitializeComponent();
            Fal();
            timer1.Start();
            
            
        }

        private void MainForm_Paint(object sender, PaintEventArgs e)
        {
            labda.Rajzol(e.Graphics);
            labda.PontotÍr(e.Graphics, pontszám);
            labda.RúgástÍr(e.Graphics, rúgás);

        }
        public void Mozgat()
        {
            ysebesség++;
          


            int y = labda.Koordináta.Y;
            int x = labda.Koordináta.X;

            x += xsebesség;
            y += ysebesség;
            labda.Koordináta = new Point(x, y);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            Pattan();
            Mozgat();

            
            Invalidate();

            if ((rúgás < 1)&&((Math.Abs(xsebesség)+Math.Abs(ysebesség))<5))
            {
                timer1.Stop();
                MessageBox.Show("Játék vége!\n" + pontszám + " pont!");
            }
        }

        private void MainForm_MouseDown(object sender, MouseEventArgs e)
        {
            if(labda.talált(e.Location)&&rúgás>0)
            {
                pontszám += Math.Abs(xsebesség) + Math.Abs(ysebesség);
                Rúgás();
                rúgás--;

            }
        }

        public void Rúgás()
        {
            Random rnd = new Random();

            int xplusz = rnd.Next(-50, 50);
            int  yplusz = rnd.Next(-50, 50);

            xsebesség += xplusz;
            ysebesség += yplusz;
        }

      
    }
}
